#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_game_level_config.h"
std::auto_ptr<M_game_level_config> M_game_level_config::msSingleton(nullptr);

int M_game_level_config::GetCount()
{
	return (int)mMapData.size();
}

const M_game_level_configData* M_game_level_config::GetData(int64_t ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int64_t, M_game_level_configData>& M_game_level_config::GetMapData()
{
	return mMapData;
}

void M_game_level_config::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_game_level_config.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_game_level_configData data;
		data.mleve = element->IntAttribute("leve");
		data.mup_exp = element->IntAttribute("up_exp");
		data.mmonster_num = element->IntAttribute("monster_num");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_game_level_config Loaded. Load Data:%u", mMapData.size());
}

void M_game_level_config::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_game_level_config");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_game_level_config");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_game_level_configData data;
		LuaCfgHelper::readInt(L, "leve", data.mleve);
		LuaCfgHelper::readInt(L, "up_exp", data.mup_exp);
		LuaCfgHelper::readInt(L, "monster_num", data.mmonster_num);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_game_level_config Loaded. Load Data:%u", mMapData.size());
}

void M_game_level_config::Reload()
{
	mMapData.clear();
	Load();
}

M_game_level_config* M_game_level_config::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_game_level_config());
	}
	return msSingleton.get();
}

void M_game_level_config::Release()
{
	msSingleton.reset(nullptr);
}
